require "dependencies_collector/version"
require 'bundler'
require 'json'
require 'net/http'
require 'uri'
require 'rbconfig'

module DependenciesCollector

	class Collector

		def execute
			data = { packages: parsingGemfile , opreating_system: RbConfig::CONFIG["arch"]}
			puts parsingDependencies(JSON.parse((requestDependencies(data).body)))
		end

		# Parsing Gemfile.lock to get gems list
		def parsingGemfile
			gems_list = Bundler::LockfileParser.new(Bundler.read_file("Gemfile.lock")).specs
			gems_list = gems_list.map {|s| {"name":s.name,"version":s.version}}
		end

		# Calling Api Service to get dependencies
		def requestDependencies(packages)
			# Create the HTTP objects
			uri = URI.parse("http://localhost:3000/api/packages/dependencies")
			http = Net::HTTP.new(uri.host, uri.port)

			request = Net::HTTP::Post.new(
			    uri.request_uri,
			    'Content-Type' => 'application/json'
			    )
			request.body = packages.to_json

			# Send the request
			response = http.request(request)
		end

		# Parsing packges dependencies to final dependencies list
		def parsingDependencies(packages)
			final_result = Array.new
			packages.each do |package|
				package.first['dependencies'].each do |library|
					final_result.push(library['library_name']) if not final_result.include?(library)
				end
			end
			puts final_result
		end

	end

	x = Collector.new
	x.execute

end
